;;; -*-lisp-*-
;;;
;;; Implementation of file-location protocol
;;;
;;; (c) 2009 Straylight/Edgeware
;;;

;;;----- Licensing notice ---------------------------------------------------
;;;
;;; This file is part of the Sensble Object Design, an object system for C.
;;;
;;; SOD is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 2 of the License, or
;;; (at your option) any later version.
;;;
;;; SOD is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with SOD; if not, write to the Free Software Foundation,
;;; Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

(cl:in-package #:sod-parser)

;;;--------------------------------------------------------------------------
;;; File location objects.

(let ((null-file-location (make-file-location nil nil nil)))
  (defmethod file-location ((thing t)) null-file-location))

(defmethod file-location ((stream stream))
  (make-file-location (stream-pathname stream) nil nil))

(defmethod print-object ((object file-location) stream)
  (maybe-print-unreadable-object (object stream :type t)
    (format stream "~:[<unknown>~;~:*~A~]~@[:~D~]~@[:~D~]"
	    (file-location-filename object)
	    (file-location-line object)
	    (file-location-column object))))

(defmethod make-load-form ((object file-location) &optional environment)
  (make-load-form-saving-slots object :environment environment))

;;;----- That's all, folks --------------------------------------------------
