;;; -*-lisp-*-
;;;
;;; Additional stream protocol.
;;;
;;; (c) 2009 Straylight/Edgeware
;;;

;;;----- Licensing notice ---------------------------------------------------
;;;
;;; This file is part of the Sensble Object Design, an object system for C.
;;;
;;; SOD is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 2 of the License, or
;;; (at your option) any later version.
;;;
;;; SOD is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with SOD; if not, write to the Free Software Foundation,
;;; Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

(cl:in-package #:sod-parser)

;;;--------------------------------------------------------------------------
;;; Discovery of file names.

(export 'stream-pathname)
(defgeneric stream-pathname (stream)
  (:documentation
   "Returns the pathname of the file that STREAM is open on.

   If STREAM is open on a file, then return the pathname of that file.
   Otherwise return nil.")

  ;; Provide some default methods.  Most streams don't have a pathname.
  ;; File-based streams provide a pathname, but it's usually been merged with
  ;; `*default-pathname-defaults*' or some such, which has made it absolute,
  ;; which isn't ideal.  We'll hack around this in more useful classes later.
  (:method ((stream stream)) nil)
  (:method ((stream file-stream)) (pathname stream)))

;;;----- That's all, folks --------------------------------------------------
